;Venus Lander version 1.2 par Thibaut Chevalier
;Tous les aliases sont dfinis ici
; ascr.h n'est pas insr dans ce code : Attention, j'ai modifi la valeur "RightClip". Utiliser le fichier ascr inclus dans le fichier zip !!


clipmask            = $f200     ;
rows2put            = $f201     ; PutSprite_MSB variables
bitmask             = $f202     ;

coord_y             = $f203
coord_x             = $f204
speed_x             = $f205
speed_y             = $f206
gravit             = $f207
fuel                = $f209
touche_cette_fois   = $f20a
mont_haut_bas       = $f20b
plat_hauteur        = $f20c
barre_haut_adresse  = $f20d
barre_bas_adresse   = $f20f
presentation        = $f211
reprise_rapide      = $f212
temporary           = $f213
temporary_2         = $f214     ; 2 octets
espace_libre        = $f100
LEM_decor           = espace_libre+144
flam_gauche_decor   = espace_libre+152
flam_droite_decor   = espace_libre+160
flam_haut_decor     = espace_libre+168
flam_bas_decor      = espace_libre+176

_asm_exec_ram       = $d748
_runindicoff        = $4ab1
_runindicon         = $4aad
_clrLCD             = $4a7e
_penCol             = $c37c
_penRow             = $c37d
_vputs              = $4aa5
_vputmap            = $4aa1     ; display variable width character (A=char)
_pause              = $4d43
GET_KEY             = $5371
K_NOKEY             = $00       ; pas de touche presse
K_F5                = $31
K_F4                = $32       
K_F3                = $33
K_F2                = $34
K_F1                = $35
K_0                 = $21       ; 0, Y
K_9                 = $14       ; 9, N
K_ENTER             = $09       ; Enter
K_EXIT              = $37       ; exit
K_PLUS              = $0A       ; +
K_MINUS             = $0B       ; -
K_MORE              = $38       ; more
_cphlde             = $403C
UNPACK_HL           = $4044
_OP1                = $c089
_SET_ABS_SRC_ADDR   = $4647
_SET_ABS_DEST_ADDR  = $5285
_SET_MM_NUM_BYTES   = $464f
_MM_LDIR            = $52ed
_asapvar            = $0D6FC    ; name of the current asm prog

.org _asm_exec_ram

    nop
    jp ProgStart
    .dw 0
    .dw ShellTitle

ShellTitle:
    .db "Venus Lander v1.2 by Thibaut Chevalier",0

ProgStart: 
    ld a, 1
    ld (presentation), a    ; presentation = 1 comme message indiquant que c'est la premiere fois que l'introduction est execute
    xor a
    ld (reprise_rapide), a
reboot:
    res 2, (iy+$12)         ; retablit le down-left-bug
    call _runindicoff
    
    call _clrLCD
    ld a, 19
    ld hl, Venus_Home
    ld de, $fc23
put_big_sprite:
    ld bc, 10
    ldir                ; copie une ligne
    push hl
    ld hl, 6
    add hl, de
    ex de, hl           ; passe  la ligne suivante sur la destination (LCD)
    pop hl              ; recupre la source (automatiquement  la ligne suivante)
    dec a
    jr nz, put_big_sprite
    
    ld hl, suite_etoiles_home
    call affichage_ciel_toil
                
    ld hl, $fd80
    ld de, $fd81
    ld bc, 31
    ld (hl), $ff
    ldir
    ld hl, $ff50
    ld de, $ff51
    ld bc, 31
    ld (hl), $ff
    ldir

    ld a, (presentation)
    or a                ; cp 0
    jp z, pas_de_presentation
    
    ld bc, (256*32)+46
    ld (_penCol), bc
    ld hl, version_string
    call _vputs
    ld bc, (256*38)+31
    ld (_penCol), bc
    call _vputs         ; hl = my_name_string
    
    ld b, 180
seconde:
    halt
    djnz seconde
    
apres_effacement_hs:
    ld hl, $ff50
    ld (barre_bas_adresse), hl
    ld hl, $fd80
    ld (barre_haut_adresse), hl
    xor a
    
bandes_zap:    
    ld hl, (barre_haut_adresse)
    ld d, h
    ld e, l
    inc de
    ld bc, 31
    ld (hl), $00
    ldir
    cp 14
    jr nc, add_1
    ld bc, 15
    or a
    sbc hl, bc
    jr sortie_1
add_1:
    ld bc, 47
    or a
    sbc hl, bc
sortie_1:
    ld (barre_haut_adresse), hl
    ld d, h
    ld e, l
    inc de
    ld bc, 31
    ld (hl), $ff
    ldir
    ld hl, (barre_bas_adresse)
    ld d, h
    ld e, l
    inc de
    ld bc, 31
    ld (hl), $00
    ldir
    cp 14
    jr c, add_2
    ld bc, 15
    or a
    sbc hl, bc
    jr sortie_2
add_2:
    ld bc, 47
    or a
    sbc hl, bc
sortie_2:
    ld (barre_bas_adresse), hl
    ld d, h
    ld e, l
    inc de
    ld bc, 31
    ld (hl), $ff
    ldir
    
    halt
    halt
    halt
    
    inc a
    cp 28
    jr nz, bandes_zap
    
pas_de_presentation:
    xor a
    ld (presentation), a
    
    ld bc, (256*27)+15
    ld (_penCol), bc
    ld hl, facile_string
    ld de, high_score 
    ld b, 3
    
menu_principal_loop:
  push bc
    call _vputs
    push hl
        ld hl, _penCol
        ld (hl), 61
        ld hl, hs_string
        call _vputs
        ld a, (de)      ; a = highscore
        cp 10
        call c, short_number
        ld h, 0
        ld l, a
        push de
            call DisplayHL
        pop de
        ex de, hl       ; ld hl, de
        inc hl
        call _vputs     ; affiche "/x4 by xxx"
        ex de, hl
    pop hl              ; hl est l'adresse de facile_string ou moyen_string ou difficile_string
    ld a, (_penRow)    
    ld c, 15            ; c = colonne (tout  gauche)
    add a, 6
    ld b, a             ; b = range suivante
    ld (_penCol), bc
  pop bc
  djnz menu_principal_loop  
    
    ld bc, (256*45)+15
    ld (_penCol), bc
    call _vputs         ; affiche "F4 ..."
    ld a, 88
    ld (_penCol), a
    call _vputs         ; affiche "F5 ..."
        
getdebut:
    call GET_KEY  
    ld hl, reprise_rapide
    cp K_F1
    jr z, partie_facile
    cp K_F2
    jr z, partie_moyen
    cp K_F3
    jr z, partie_dur
    cp K_F5
    jp z, fin
    cp K_ENTER
    jr z, rapid
    cp K_EXIT
    jp z, fin
    cp K_F4
    jr nz, getdebut

efface_les_highscores:
    ld hl, $fed0
    call prep_text_place
    ld bc, (256*45)+24
    ld (_penCol), bc
    ld hl, clear_hs_string
    call _vputs
    res 3,(iy+5)            ; texte noir sur fond blanc
key_hs_loop:
    call GET_KEY
    cp K_9
    jp z, reboot
    cp K_0
    jr nz, key_hs_loop
    
    ld hl, high_score
    ld b, 3
effacement_loop_1:
    ld (hl), 0
    ld de, 8
    add hl, de
    ld c, b
    ld b, 3
effacement_loop_2
    ld (hl), '-'
    inc hl
    djnz effacement_loop_2
    inc hl
    ld b, c
    djnz effacement_loop_1
    jp apres_effacement_hs

rapid:
    ld hl, reprise_rapide
    ld a, (hl)
    or a
    jr z, getdebut
    cp 1
    jr z, partie_facile        
    cp 2
    jr z, partie_moyen
    jr partie_dur  
partie_facile:
    ld (hl), 1         ; numro de la reprise rapide
    ld a, 30        ; a = fuel
    jr retour_difficult
partie_moyen:
    ld (hl), 2
    ld a, 40
    jr retour_difficult
partie_dur:
    ld (hl), 3
    ld a, 50
retour_difficult:    
    ld (fuel), a
    call _clrLCD
    ld b, a
    ld c, 127
    call DrawVert
    
    set 2, (iy+$12)     ; corrige le down-left-bug (mais oblige a lire les 'key presses' par les ports)
    
    ld hl, initialisation
    ld de, coord_y
    ld bc, 6
    ldir
    
    ld hl, suite_etoiles_jeu
    call affichage_ciel_toil
    
    ld a, r
    and %00000001
    jr z, monts2
    
    ld hl, monts_lointains_1
    call affichage_monts_lointains
    ld hl, monts_lointains_2
    jr affichage_montagne_der_der
monts2:
    ld hl, monts_lointains_3
    call affichage_monts_lointains
    ld hl, monts_lointains_4
    
affichage_montagne_der_der:
    call affichage_monts_lointains
        
    ld a, 110
    call Random
    inc a
    ld e, a
    ld b, 58
    ld c, 0
    
    xor a
    ld (mont_haut_bas), a

decor_affich_loop:    
    ld a, e
    cp c
    jr nz, pas_de_plat
    add a, 14
    ld d, a
    ld hl, plat_hauteur
    ld (hl), b
plat_loop:
    push bc
    call DrawVert
    pop bc
    inc c
    ld a, c
    cp d
    jr nz, plat_loop
pas_de_plat:
    ld a, 6
    call Random
    cp 5
    jr nz, controle_bouts
    ld a, (mont_haut_bas)
    xor $ff
    ld (mont_haut_bas), a
controle_bouts:
    ld a, b
    cp 54
    jr nz, pas_en_haut
    ld a, $ff
    ld (mont_haut_bas), a
pas_en_haut:
    ld a, b
    cp 62
    jr nz, pas_en_bas
    ld a, $00
    ld (mont_haut_bas), a
pas_en_bas:
    ld a, (mont_haut_bas)
    or a                    ; cp 0
    jr z, pente_en_montee
    inc b
    jr retour_de_pente
pente_en_montee:
    dec b
retour_de_pente:
    push bc
    call DrawVert
    pop bc
    inc c
    
    ld a, 126
    cp c
    jr nz, decor_affich_loop
    
    ld bc, 60*256+5
    ld hl, LEM
    ld de, LEM_decor
    call PutSprite_MSB
        
getloop:
    xor a
    ld (touche_cette_fois), a
    
    ld a,%00111111
    out (1),a
    in a,(1)
    rlca
    jp nc, pause
    
    ld a,%01111110 
    out (1),a
    in a,(1)
    bit 2,a
    call z, droite
retour_droite:
    ld a,%01111110
    out (1),a 
    in a,(1)
    bit 1,a
    call z, gauche
retour_gauche:
    ld a,%01111110
    out (1),a
    in a,(1)
    bit 3,a 
    call z, haut
retour_haut:
    ld a,%01111110
    out (1),a
    in a,(1)
    rrca
    call nc, bas
retour_bas:
    ld a,%00111111
    out (1),a
    in a,(1)
    bit 6,a
    jp z, reboot

    ld a, (touche_cette_fois)
    or a
    jp z, pas_de_touche
    
    ld bc, (coord_y)
    ld a, (speed_x)
    add a, b
    ld b, a
    ld a, (speed_y)
    add a, c
    ld c, a
    ld (coord_y), bc
    call controle_collision
    ld hl, LEM
    ld de, LEM_decor
    call PutSprite_MSB
    
    ld bc, (coord_y)
    ld a, b
    add a, 8
    ld b, a
    ld de, flam_droite_decor
    ld a, (touche_cette_fois)
    bit 0, a
    jr z, pas_de_pousse_droite
    ld hl, flam_droite
    jr put_droite    
pas_de_pousse_droite:
    ld hl, vide
put_droite:
    call PutSprite_MSB
    
    ld bc, (coord_y)
    ld a, b
    sub 8
    ld b, a
    ld de, flam_gauche_decor
    ld a, (touche_cette_fois)
    bit 1, a
    jr z, pas_de_pousse_gauche
    ld hl, flam_gauche
    jr put_gauche    
pas_de_pousse_gauche:
    ld hl, vide
put_gauche:
    call PutSprite_MSB
    
    ld bc, (coord_y)
    ld a, c
    sub 8
    ld c, a
    ld de, flam_haut_decor
    ld a, (touche_cette_fois)
    bit 2, a
    jr z, pas_de_pousse_haut
    ld hl, flam_haut
    jr put_haut 
pas_de_pousse_haut:
    ld hl, vide
put_haut:
    call PutSprite_MSB
    
    ld bc, (coord_y)
    ld a, c
    add a, 8
    ld c, a
    ld de, flam_bas_decor
    ld a, (touche_cette_fois)
    bit 3, a
    jr z, pas_de_pousse_bas
    ld hl, flam_bas
    jr put_bas
pas_de_pousse_bas:
    ld hl, vide
put_bas:
    call PutSprite_MSB

pas_de_touche:
    ld de, (gravit)
    dec de
    ld hl, 0
    call _cphlde
    ld (gravit), de
    jr nz, pas_de_touche 
    ld de, 8000
    ld (gravit),de
    ld a, (touche_cette_fois)
    or a
    jr z, pas_de_touche_2
    
    ld bc, (coord_y)
    ld a, b
    add a, 8
    ld b, a
    ld hl, flam_droite_decor
    call PutSprite
    ld a, b
    sub 16
    ld b, a
    ld hl, flam_gauche_decor
    call PutSprite
    ld bc, (coord_y)
    ld a, c
    sub 8
    ld c, a
    ld hl, flam_haut_decor
    call PutSprite
    ld a, c
    add a, 16
    ld c, a
    ld hl, flam_bas_decor
    call PutSprite    
    
    ;jr effet_gravit
pas_de_touche_2:
    ld bc, (coord_y)
    ld hl, LEM_decor
    call PutSprite

effet_gravit:    
    ld hl, speed_y
    inc (hl)
    ld a, (hl)
    add a, c
    ld c, a
    ld a, (speed_x)
    add a, b
    ld b, a
    ld (coord_y), bc
    call controle_collision
    ld hl, LEM
    ld de, LEM_decor
    call PutSprite_MSB
    
    jp getloop


droite:
    call fuel_conso
    ret c
    ld a, (touche_cette_fois)
    set 0, a
    call reduction
    ld hl, speed_x
    dec (hl)
    dec (hl)
    ret 
gauche:
    call fuel_conso
    ret c
    ld a, (touche_cette_fois)
    set 1, a
    call reduction
    ld hl, speed_x
    inc (hl)
    inc (hl)
    ret  
haut:
    call fuel_conso
    ret c
    ld a, (touche_cette_fois)
    set 2, a
    call reduction
    ld hl, speed_y
    inc (hl)
    inc (hl)
    ret
bas:
    call fuel_conso
    ret c
    ld a, (touche_cette_fois)
    set 3, a
    call reduction
    ld hl, speed_y
    dec (hl)
    dec (hl)
    ret

reduction:
    ld (touche_cette_fois), a
    ld bc, (coord_y)
    ld hl, LEM_decor
    call PutSprite
    ret

controle_collision:
    ld a, 192
    cp c
    ret c
    
    ld a, c
    sub 128
    cp 64
    jp c, lost_in_space     ; lost in space si 128 < c < 192
    
    ld a, 37
    cp c
    ret nc
    ld a, 55
    cp c
    jr nc, controle_sous_vaisseau
    ld a, 128
    cp c
    jr c, controle_sous_vaisseau
    jp crash_pas_sur_plat
controle_sous_vaisseau:
    ld e, b
    ld a, c
    add a, 8
    ld d, a
     push bc
    call FindPixel
    ld d, (hl)
    inc hl
    ld e, (hl)
    ld a, b
    and %00000111
    jr z, cal_sur_la_grille
    ld b, a    
collision_sous_loop:
    sla e
    rl d
    djnz collision_sous_loop
cal_sur_la_grille:
     pop bc
    ld a, d
    cp $00
    ret z
    cp $ff
    jp nz, crash_pas_sur_plat
    
    ld a, (speed_y)
    cp 3
    jp nc, speed_pas_ok
    ld a, (speed_x)
    cp 4
    jp nc, speed_pas_ok
    ld a, (plat_hauteur)
    sub 8
    ld c, a
    ld hl, LEM
    ld de, LEM_decor
    call PutSprite_MSB
    ld hl, $fc00
    call prep_text_place
    ld bc, (0<<8)+17
    ld (_penCol), bc
    ld hl, safe_string
    call _vputs
    
    ld hl, high_score-12
    ld a, (reprise_rapide)
    ld b, a
    ld c, 12
    xor a
mult_loop:
    add a, c
    djnz mult_loop
    ld b, 0
    ld c, a
    add hl, bc
    ld a, (fuel)
    ld b, a
    ld a, 64
    sub b
    ld b, a     ; b = 64 -(fuel)
    ld a, (hl)  ; a = highscore
    cp b
    jp nc, crash_or_safe    ; if nc, no highscore
    ld (hl), b  ; save new highscore
    push hl
        ld hl, $fc80
        call prep_text_place
        ld hl, new_hs_string
        ld bc, (8<<8)+2
        ld (_penCol), bc
        call _vputs
    pop hl
    ld bc, 8
    add hl, bc
    ld (temporary_2), hl
    xor a
    ld (temporary), a
    
    res 2, (iy+$12)         ; retablit le down-left-bug

other_character:
    ld a, '_'
    call _vputmap
    ld a, (_penCol)
    sub 4
    ld (_penCol), a
wrong_character:    
    call GET_KEY
    or a                   ; cp K_NOKEY
    jr z, wrong_character
    cp K_ENTER
    jr z, erase_the_end    ; saving finished
    sub $0a
    cp $2f-$0a
    jr nc, wrong_character
    ld hl, characters
    ld b, 0
    ld c, a     ; bc = offset
    add hl, bc  ; get adress of our character
    ld a, (hl)  ; our charcter is in the register a
    or a
    jr z, wrong_character   ; in the table, 0 means that it is not a character key
  push af
    call _vputmap           ; write the letter
    ld hl, (temporary_2)
    ld b, 0
    ld a, (temporary)
    ld c, a
    add hl, bc
  pop af
    ld (hl), a      ; saves the character in the hiscore table
    ld a, (temporary)
    inc a
    ld (temporary), a
    cp 3            ; if a (=temporary)= 6, stop to check for keys
    jr nz, other_character
enter_loop:
    call GET_KEY
    cp K_ENTER
    jr nz, enter_loop
    jr reboot_2
erase_the_end:
    ld a, (temporary)
    ld hl, (temporary_2)
    ld b, 0
    ld c, a
    add hl, bc
erase_loop:
    ld (hl), ' '
    inc hl
    ld a, (hl)
    or a            ; cp 0
    jr nz, erase_loop
    jr reboot_2 
    
lost_in_space:
    ld hl, $fc00
    call prep_text_place
    ld bc, (0<<8)+2
    ld hl, lost_string
    ld (_penCol), bc
    call _vputs
    jr crash_or_safe

speed_pas_ok:
    ld a, (plat_hauteur)
    sub 8
    ld c, a
crash_pas_sur_plat_retour:
    ld hl, LEM_crashed
    ld de, LEM_decor
crash_jump:    
    call PutSprite_MSB
    ld hl, $fc00
    call prep_text_place
    ld bc, (0<<8)+26
    ld hl, crashed_string
    ld (_penCol), bc
    call _vputs
crash_or_safe:       
    res 2, (iy+$12)         ; retablit le down-left-bug
    call _pause
reboot_2:
    pop bc
reboot_3:
    res 3,(iy+$5)           ; texte noir sur fond blanc
    jp reboot
crash_pas_sur_plat:
    ld c, 55
    jr crash_pas_sur_plat_retour
  
pause:
    res 2, (iy+$12)         ; retablit le down-left-bug (permet de lire le clavier sans passer par les ports :)
    
    ld hl, $fdc0
    ld de, espace_libre
    ld bc, 144
    ldir
    
    ld hl, $fdd0
    call prep_text_place
    
    ld bc, (256*29)+48
    ld (_penCol), bc
    ld hl, pause_string
    call _vputs
    set 3,(iy+$5)           ; texte noir sur fond blanc

pause_loop:
    call GET_KEY
    or a            ; cp NO_KEY
    jr z, pause_loop
    cp K_PLUS
    jr z, contrast_plus
    cp K_MINUS
    jr z, contrast_moins
    cp K_EXIT
    jr z, reboot_3 

    ld de, $fdc0
    ld hl, espace_libre
    ld bc, 144
    ldir
    
    set 2, (iy+$12)         ; limine le down-left-bug   
    jp getloop
         
fin:
    ld hl,_asapvar      ;hl->name of program
    rst 20h             ;copy to OP1
    rst 10h             ;_findsym
    xor a
    ld hl,data_start-_asm_exec_ram+4        ;offset
    add hl,de                   ;hl=pointer to data in original prog
    adc a,b                     ;in case we overlapped pages
    call _SET_ABS_DEST_ADDR
    xor a                       ;no absolute addressing now
    ld hl,data_start            ;get data from here
    call _SET_ABS_SRC_ADDR
    ld hl,data_end-data_start   ;number of bytes to save
    call _SET_MM_NUM_BYTES
    call _MM_LDIR               ;copy data
    
    call _runindicon
    call _clrLCD
    res 2, (iy+$12)         ; retablit le down-left-bug 
    ret
    
prep_text_place:
    ld d, h
    ld e, l
    inc de
    ld (hl), $ff 
    ld bc, 111
    ldir    
    set 3,(iy+5)            ; texte blanc sur fond noir
    ret

contrast_plus:
    ld a, ($C008)   ; recupre la valueur du contraste
    inc a           ; l'incremente
    ld ($C008), a   ; la sauvegarde
    out (2), a      ; envoie la nouvelle valeur au port 2 (qui gre le contraste) : $C008 est juste une valeur image de contrast
    jr pause_loop

contrast_moins:
    ld a, ($C008)   ; c'est la mme chose
    dec a
    ld ($C008), a
    out (2), a
    jr pause_loop

#include "ascr.h"

fuel_conso:
    ld a, (fuel)
    cp 64
    jr nz, fuel_ok
    scf
    ret
fuel_ok
    ld e, 127
    ld d, a
    call FindPixel
    cpl
    and (hl)
    ld (hl), a
    inc d
    ld a, d
    ld (fuel), a
    or a
    ret

affichage_ciel_toil:      ; affiche des toiles a partir d'une liste de coordonnes finissant par 0
    ld b, (hl)
    xor a
    cp b
    ret z
    inc hl
    ld c, (hl)
    inc hl
     push hl
    ld hl, etoile
    ld de, espace_libre
    call PutSprite_MSB
     pop hl
    jr affichage_ciel_toil

affichage_monts_lointains:  ; affiche le fond en pointills
    ld c, (hl)              ; c = pente ($00 = monte, $ff = descente)
    inc hl
    ld e, (hl)              ; e, d = coordonnes du point
    inc hl
    ld d, (hl)
    inc hl

pointills_loop_g:    
    ld b, (hl)              ; b = longueur de la pente avant le prochain sommet
pointills_loop:
     push hl
      push bc
      call FindPixel
      or (hl)
      ld (hl), a              ; allumage du point
      pop bc
     pop hl
    ld a, c
    cp $ff
    jr z, pointills_descente
    dec d
    dec d
    jr avancement_pointills
pointills_descente:
    inc d
    inc d
avancement_pointills:
    inc e
    inc e                   ; mise a jour des coordonnes pour le prochain point
    djnz pointills_loop
    inc hl                  ; hl pointe sur la longueur de la prochaine pente
    xor a
    cp (hl)
    ret z                   ; la suite se termine par 0 ; detection de ce zero et sortie
    dec a                   ;o   = ld a, $ff
    xor c                   ;oo
    ld c, a                 ;ooo changement de pente  
    jr pointills_loop_g 
    
short_number:
    ld c, a         ; save a
    ld hl, _penCol
    ld a, (hl)
    add a, 4        ; add 4 to (_penCol) in a
    ld (hl), a      ; load it in (_penCol)
    ld a, c         ; restore a
    ret


Random:            ; Creates a random number 0 <= x < A
 push bc
 push de
 ld b,a
 ld a,r
 add a,a
 ld hl,0
 ld d,0
 ld e,a
RMul:
 add hl,de
 djnz RMul
 ld a,h
 pop de
 pop bc
 ret

; =============================================================
; Draw a line between points (c,b) and (c,63)
; =============================================================
DrawVert:
    push bc
    push de
    ld e, c
    ld d, b
    call FindPixel
    or (hl)            
    ld (hl), a
    pop de
    pop bc
    ld a, b
    cp 63
    ret z
    inc b
    jr DrawVert


; =============================================================
; Dan Eble & James Yopp FindPixel routine
; Input:  D = y, E = x
; Output: HL= addr in vid mem, A = bitmask, C is modified
; =============================================================
FindPixel:
        ld hl,FP_Bits
        ld a,e
        and $07         ; a = bit offset
        add a,l
        ld l,a
        adc a,h
        sub l
        ld h,a
        ld c,(hl)       ; c = bitmask for (hl)
            ;48 t-states up to this point
        ld hl, FP_RLD
        ld (hl),d
        ld a,e          ; a = x/8 (byte offset within row)
        rrca
        rrca   
        rrca
        rld
        or $FC 
        ld l,(hl)
        ld h,a          ; hl -> byte in vid mem
        ld a,c          ; now a = bitmask for (hl)
;121 t-states up to this point
        ret
FP_RLD: .db 0
FP_Bits: .db $80,$40,$20,$10,$08,$04,$02,$01


;====================================================================
; DisplayHL:  (idea from SCaBBy/Mardell)    [Assembly Coder's Zenith]
;  Display HL as a 5-digit decimal number with no leading zeros
;  out: AF, HL, BC, DE destroyed
;====================================================================
DisplayHL:
 ld c,'0'           ; save ascii value for zero
 ld de,_OP1+5       ; point to end of the buffer
 xor a              ; zero terminate string
 ld (de),a          ; set last byte to zero
DisplayHLl:
 call UNPACK_HL     ; next digit
 dec de             ; next position
 add a,c            ; convert to ascii
 ld (de),a          ; save digit
 ld a,h             ; load upper byte
 or l               ; check with lower byte for zero
 jr nz,DisplayHLl   ; loop
 ex de,hl           ; point to buffer
 call _vputs        ; print number
 ret                ; we're done

           
LEM:
.db %00011000
.db %00100100
.db %00100100
.db %01000010
.db %01111110
.db %00111100
.db %01000010
.db %11100111
.db %00011000
.db %00111100
.db %00111100
.db %01111110
.db %01111110
.db %00111100
.db %01000010
.db %11100111

LEM_crashed:
.db %00000000
.db %00001100
.db %00010110
.db %00110010
.db %00101010
.db %01111110
.db %00110111
.db %01111111
.db %00000000
.db %00011100
.db %00111110
.db %00111110
.db %01111110
.db %01111110
.db %00111111
.db %11111111

flam_haut:
.db %00010000
.db %00011000
.db %00011000
.db %00111100
.db %00110100
.db %00111100
.db %00011000
.db %00000000
.db %00010000
.db %00011000
.db %00011000
.db %00111100
.db %00111100
.db %00111100
.db %00011000
.db %00000000

etoile:
.db %01000000
.db %10100000
.db %01000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %01000000
.db %11100000   ; la fin d'"toile" est dans "vide"
.db %01000000
;.db %00000000
;.db %00000000
;.db %00000000
;.db %00000000
;.db %00000000

vide:
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000   ; la fin de "vide" est dans "flam_gauche"
;.db %00000000
;.db %00000000

flam_gauche:
.db %00000000
.db %00000000
.db %00011100
.db %01110110
.db %11111110
.db %00011100
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00011100
.db %01111110
.db %11111110
.db %00011100    ; les deux derniers "0" de flam_gauche sont le debut de monts_lointains_3
flam_droite:
.db %00000000
.db %00000000
.db %00111000
.db %01111110
.db %01101111
.db %00111000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00111000
.db %01111110
.db %01111111
.db %00111000
;.db %00000000
flam_bas:
.db %00000000
.db %00011000
.db %00111100
.db %00101100
.db %00111100
.db %00011000
.db %00011000
.db %00001000
.db %00000000
.db %00011000
.db %00111100
.db %00111100
.db %00111100
.db %00011000
.db %00011000
.db %00001000

Venus_Home:
 .db $1F,$7D,$FF,$0E,$F9,$F7,$C7,$F8,$00,$00,$31,$C7,$80,$B1,$C7,$1C
 .db $58,$04,$00,$00,$31,$C7,$00,$70,$C7,$1C,$70,$04,$00,$00,$31,$C7
 .db $50,$70,$47,$1C,$70,$F8,$00,$00,$31,$C7,$57,$B0,$07,$1C,$70,$F0
 .db $00,$00,$31,$C7,$02,$30,$07,$1C,$7C,$08,$00,$00,$30,$87,$07,$B0
 .db $07,$1C,$4F,$C4,$00,$00,$18,$0F,$08,$70,$07,$08,$53,$C4,$00,$00
 .db $18,$0F,$00,$71,$07,$00,$70,$04,$00,$00,$0C,$1B,$00,$71,$87,$00
 .db $70,$04,$00,$00,$07,$73,$80,$F1,$C7,$80,$B8,$0C,$00,$00,$03,$E1
 .db $FF,$FF,$FD,$FF,$BF,$F8,$00,$00,$00,$80,$FF,$BF,$78,$FF,$1F,$F0
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$18,$73,$2F,$3D,$E0,$00,$00,$00,$00,$00,$18,$DB,$AD,$B1,$B0
 .db $00,$00,$00,$00,$00,$18,$FB,$ED,$B9,$E0,$00,$00,$00,$00,$00,$1E
 .db $DB,$6D,$BD,$B0,$00,$00,$00,$00,$00,$1E,$DB,$6F,$3D,$B0

suite_etoiles_home: .db 10,7,29,19,92,10,111,7,120,13,105,58,16,60,53,61,0
suite_etoiles_jeu: .db 34,11,82,4,66,19,117,9,0
monts_lointains_1: .db $ff,0,32,3,3,1,5,7,5,2,2,3,6,5,1,6,5,3,6,0
monts_lointains_2: .db $00,94,34,6,6,0
monts_lointains_3: .db $00,0,41,6,4,2,3,7,5,2,4,6,2,2,8,6,6,0
monts_lointains_4: .db $00,16,33,6,5,0

characters:
    .db "XTOJE",0,0," WSNID",0,0
    .db "ZVRMHC",0,0,"YUQLGB",0,0,0,".PKFA"

version_string: .db "version 1.2", 0
mon_nom_string: .db "by Thibaut Chevalier", 0
facile_string: .db "F1 - Easy", 0
moyen_string: .db "F2 - Medium", 0
difficile_string: .db "F3 - Hard", 0
remise_a_0_high_score: .db "F4 - Reset highscores", 0
quitter_string: .db "F5 - Exit", 0
safe_string: .db "LEM landed safely on Venus !", 0
crashed_string: .db "LEM crashed on Venus !", 0
lost_string: .db "LEM disappeared from radar screens !", 0
pause_string: .db "- Paused -", 0
hs_string: .db "hi: ",0
new_hs_string: .db "New hiscore ! Enter your name : ", 0
clear_hs_string: .db "Reset highscores ? (Y/N)", 0

initialisation:
.db 5          ; coord_y = 5
.db 60         ; coord_x = 60
.db 0          ; speed_x = 0
.db 0          ; speed_y = 0
.db $40
.db $1f        ; gravit = 8000

data_start:
high_score:
.db 0,"/34 by ---",0
.db 0,"/24 by ---",0
.db 0,"/14 by ---",0
data_end:

.end
